<ng-container *ngIf="vm$ | async as vm">
  <ng-container *subscribe="vm.pushDataMutation.result$ as pushData">
    <ng-container *ngIf="vm.listTahunReversed as listTahunReversed">
      <div
        [style.overflow-x]="'auto'"
        [style.border-top-left-radius.px]="16"
        [style.border-top-right-radius.px]="16"
        [style.border]="'2px solid #E0E0E0'"
        [style.border-bottom]="'none'"
      >
        <table
          [ngClass]="[jds.table, jds.mb(0)]"
          [style.border-collapse]="'separate'"
          [style.border-spacing]="0"
          stickyTable
          role="table"
          aria-label="List Ringkasan Urusan"
          aria-describedby="Table List Ringkasan Urusan"
        >
          <thead>
            <tr>
              <th
                #stickyColumn
                [ngClass]="[jds.bg('#E9F2FE')]"
                [style.border]="'1px solid #E0E0E0'"
                [style.border-top]="'none'"
                [style.border-left]="'none'"
                [style.width.px]="42"
                [style.min-width.px]="42"
                stickyColumn
              >
                No
              </th>
              <th
                #stickyColumn
                [ngClass]="[jds.bg('#E9F2FE')]"
                [style.border]="'1px solid #E0E0E0'"
                [style.border-top]="'none'"
                [style.width.px]="156"
                [style.min-width.px]="156"
                stickyColumn
              >
                <span [style.white-space]="'nowrap'">Kode SSD</span>
              </th>
              <th
                [ngClass]="[jds.bg('#E9F2FE')]"
                [style.border]="'1px solid #E0E0E0'"
                [style.border-top]="'none'"
                [style.width.px]="600 - 97"
                [style.min-width.px]="600 - 97"
                stickyColumn
              >
                Uraian
              </th>
              <th
                [ngClass]="[jds.bg('#E9F2FE')]"
                [style.border]="'1px solid #E0E0E0'"
                [style.border-top]="'none'"
                [style.width.px]="149"
                [style.min-width.px]="149"
                stickyColumn
              >
                Satuan
              </th>
              <ng-container
                *ngFor="let tahun of listTahunReversed; let i = index"
              >
                <th
                  [ngClass]="[jds.bg('#E9F2FE')]"
                  [style.border]="'1px solid #E0E0E0'"
                  [style.border-top]="'none'"
                  [style.border-right]="
                    i === listTahunReversed.length - 1
                      ? 'none'
                      : '1px solid #E0E0E0'
                  "
                  [colorScheme]="'gray'"
                  [colorCustom]="true"
                  [style.width.px]="140"
                  [style.min-width.px]="140"
                  scope="col"
                  jdsBiTableHead
                  column="type"
                >
                  <span
                    [style.width.%]="100"
                    [style.text-align]="'right'"
                    >{{ tahun.label }}</span
                  >

                  <!-- <div
                    [style.cursor]="'pointer'"
                    filter
                    role="button"
                  >
                    <jds-bi-hosted-dropdown
                      [jdsBiDropdownLimitWidth]="'custom'"
                      [jdsBiDropdownMinWidth]="240"
                      [content]="dropdownTypeData"
                    >
                      <i
                        class="tblhd-icon"
                        [ngClass]="['active']"
                      ></i>
                    </jds-bi-hosted-dropdown>
                  </div> -->
                </th>
              </ng-container>
            </tr>
          </thead>
          <tbody>
            <ng-container
              *ngIf="
                (vm.bidangUrusanMasterData?.data?.list ?? []).length === 0 &&
                !vm.listIndikatorBidangUrusan
              "
            >
              <ng-container *ngTemplateOutlet="loading" />
            </ng-container>
            <ng-container
              *ngIf="vm.listIndikatorBidangUrusan as listIndikatorBidangUrusan"
            >
              <ng-container *ngIf="listIndikatorBidangUrusan.isLoading">
                <ng-container *ngTemplateOutlet="loading" />
              </ng-container>
              <ng-container *ngIf="listIndikatorBidangUrusan.isSuccess">
                <ng-container *ngIf="listIndikatorBidangUrusan.isFetching">
                  <ng-container *ngTemplateOutlet="loading" />
                </ng-container>
                <ng-container *ngIf="!listIndikatorBidangUrusan.isFetching">
                  <ng-container
                    *ngIf="listIndikatorBidangUrusan?.data?.list?.length > 0"
                  >
                    <tr
                      *ngFor="
                        let row of listIndikatorBidangUrusan?.data?.list ?? [];
                        let i = index
                      "
                      [style.height.px]="1"
                    >
                      <td
                        [style.border]="'1px solid #E0E0E0'"
                        [style.border-left]="'none'"
                        [style.width.px]="42"
                        [style.min-width.px]="42"
                        [style.background]="'#FFFFFF'"
                        stickyColumn
                      >
                        {{
                          vm.paginationParamsIndikatorUrusan.perPage *
                            (vm.paginationParamsIndikatorUrusan.currentPage -
                              1) +
                            (i + 1)
                        }}
                      </td>
                      <td
                        [style.border]="'1px solid #E0E0E0'"
                        [style.background]="'#FFFFFF'"
                        stickyColumn
                      >
                        {{ row.kode_indikator }}
                      </td>
                      <td
                        [style.border]="'1px solid #E0E0E0'"
                        [style.background]="'#FFFFFF'"
                        stickyColumn
                      >
                        {{ row.uraian_indikator }}
                      </td>
                      <td
                        [style.border]="'1px solid #E0E0E0'"
                        [style.background]="'#FFFFFF'"
                        stickyColumn
                      >
                        {{ row.satuan }}
                      </td>
                      <ng-container
                        *ngFor="let tahun of listTahunReversed; let i = index"
                      >
                        <td
                          [style.border]="'1px solid #E0E0E0'"
                          [style.width.px]="140"
                          [style.height]="'inherit'"
                          [style.min-width.px]="140"
                          [style.border-right]="
                            i === listTahunReversed.length - 1
                              ? 'none'
                              : '1px solid #E0E0E0'
                          "
                          [ngClass]="
                            row.ewalidata_data[getRincianIndex(row, tahun)]
                              ?.status_verifikasi_walidata === 'Y'
                              ? [jds.bg('#E6F6EC')]
                              : isWalidata
                              ? []
                              : [jds.p(0)]
                          "
                        >
                          <div
                            [ngClass]="[jds.d('flex')]"
                            [style.align-items]="'center'"
                            [style.height.%]="100"
                            [style.width.%]="100"
                            [style.justify-content]="'end'"
                          >
                            <input
                              *ngIf="
                                row.ewalidata_data[getRincianIndex(row, tahun)]
                                  ?.status_verifikasi_walidata !== 'Y' && isOPD
                              "
                              [(ngModel)]="
                                row.ewalidata_data[getRincianIndex(row, tahun)]
                                  .data
                              "
                              [style.border]="
                                row.ewalidata_data[getRincianIndex(row, tahun)]
                                  .hovered === true
                                  ? '1px solid #FFC800'
                                  : 'none'
                              "
                              [style.transition]="'none'"
                              [style.min-height.px]="46"
                              [style.height.%]="100"
                              [style.border-radius]="0"
                              [style.text-align]="'end'"
                              [ngClass]="[
                                jds.fs(16),
                                jds.px(16),
                                jds.bg('#FFF')
                              ]"
                              [disabled]="pushData.isLoading"
                              (mouseover)="
                                row.ewalidata_data[
                                  getRincianIndex(row, tahun)
                                ].hovered = true
                              "
                              (mouseleave)="
                                row.ewalidata_data[
                                  getRincianIndex(row, tahun)
                                ].hovered = false
                              "
                              (ngModelChange)="
                                row.ewalidata_data[
                                  getRincianIndex(row, tahun)
                                ].input$.next($event)
                              "
                              name="2023"
                              type="text"
                              mask="separator"
                              thousandSeparator="."
                              jdsBiInput
                            />
                            <span
                              *ngIf="
                                row.ewalidata_data[getRincianIndex(row, tahun)]
                                  ?.status_verifikasi_walidata === 'Y' ||
                                (isWalidata &&
                                  row.ewalidata_data[
                                    getRincianIndex(row, tahun)
                                  ]?.data &&
                                  row.ewalidata_data[
                                    getRincianIndex(row, tahun)
                                  ]?.data !== '')
                              "
                              [style.cursor]="'default'"
                            >
                              {{
                                +row.ewalidata_data[getRincianIndex(row, tahun)]
                                  ?.data | numberFormat
                              }}
                            </span>
                          </div>
                        </td>
                      </ng-container>
                    </tr>
                  </ng-container>

                  <ng-container
                    *ngIf="listIndikatorBidangUrusan?.data?.list?.length === 0"
                  >
                    <ng-container *ngTemplateOutlet="empty" />
                  </ng-container>
                </ng-container>
              </ng-container>
            </ng-container>
          </tbody>
        </table>
      </div>
      <ng-container
        *ngIf="vm.listIndikatorBidangUrusan as listIndikatorBidangUrusan"
      >
        <ng-container *ngIf="listIndikatorBidangUrusan.isSuccess">
          <ng-container
            *ngIf="listIndikatorBidangUrusan?.data?.list?.length > 0"
          >
            <jds-bi-pagination
              [colorScheme]="colorScheme"
              [perPageItems]="perPageItems"
              [pagination]="listIndikatorBidangUrusan.data.pagination"
              [perPage]="vm.paginationParamsIndikatorUrusan.perPage"
              [page]="vm.paginationParamsIndikatorUrusan.currentPage"
              (filterPerPage)="onPerPage($event)"
              (filterPage)="onPageChange($event)"
            />
          </ng-container>
        </ng-container>
      </ng-container>

      <ng-template #dropdownTypeData>
        <ng-select
          [searchable]="true"
          [clearable]="true"
          [closeOnSelect]="true"
          [items]="[
            { label: 'Belum Terisi', value: false },
            { label: 'Terisi', value: true }
          ]"
          bindValue="value"
          bindLabel="label"
          placeholder="Filter"
          appendTo="body"
        />
      </ng-template>

      <ng-template #loading>
        <tr *ngFor="let i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]">
          <td
            [style.border]="'1px solid #E0E0E0'"
            [style.border-left]="'none'"
            [style.background]="'#FFFFFF'"
            stickyColumn
          >
            <ng-container *ngTemplateOutlet="skeleton" />
          </td>
          <td
            [style.border]="'1px solid #E0E0E0'"
            [style.background]="'#FFFFFF'"
            stickyColumn
          >
            <ng-container *ngTemplateOutlet="skeleton" />
          </td>
          <td
            [style.border]="'1px solid #E0E0E0'"
            [style.background]="'#FFFFFF'"
            stickyColumn
          >
            <ng-container *ngTemplateOutlet="skeleton" />
          </td>
          <td
            [style.border]="'1px solid #E0E0E0'"
            [style.background]="'#FFFFFF'"
            stickyColumn
          >
            <ng-container *ngTemplateOutlet="skeleton" />
          </td>
          <ng-container
            *ngFor="let item of listTahunReversed ?? []; let idx = index"
          >
            <td
              [style.border]="'1px solid #E0E0E0'"
              [style.border-right]="
                idx === listTahunReversed.length - 1
                  ? 'none'
                  : '1px solid #E0E0E0'
              "
            >
              <ng-container *ngTemplateOutlet="skeleton" />
            </td>
          </ng-container>
        </tr>
      </ng-template>

      <ng-template #empty>
        <tr>
          <td
            [style.border]="'1px solid #E0E0E0'"
            [ngClass]="[jds.textAlign('center')]"
            [attr.colspan]="4 + (listTahunReversed?.length ?? 0)"
            [style.border-left]="'none'"
            [style.border-right]="'none'"
          >
            Rincian uraian saat ini belum tersedia.
          </td>
        </tr>
      </ng-template>

      <ng-template #skeleton>
        <div class="wrapper-skeleton">
          <ngx-skeleton-loader
            [theme]="{
              width: '80%',
              'border-radius': '0',
              height: '22px',
              'margin-bottom': '0px'
            }"
          />
        </div>
      </ng-template>
    </ng-container>
  </ng-container>
</ng-container>
